#include "FLAME.h"

int FLA_FS_2x2( FLA_Obj B, 
		FLA_Obj D, FLA_Obj E, 
                FLA_Obj p, FLA_Obj r, FLA_Obj s,
		FLA_Obj L, 
                FLA_Obj YT, 
                FLA_Obj YB, int nb_alg )
{
  FLA_Apply_pivots( FLA_LEFT, FLA_NO_TRANSPOSE, p, YT );

  FLA_Trsm( FLA_LEFT, FLA_LOWER_TRIANGULAR, FLA_NO_TRANSPOSE, FLA_UNIT_DIAG,
  	    FLA_ONE, B, YT );

  FLA_FS_SA_LIN_blk( L, 
                     D, r, YT, 
       	                     YB, nb_alg );

  FLA_Apply_pivots( FLA_LEFT, FLA_NO_TRANSPOSE, s, YB );
  
  FLA_Trsm( FLA_LEFT, FLA_LOWER_TRIANGULAR, FLA_NO_TRANSPOSE, FLA_UNIT_DIAG,
  	    FLA_ONE, E, YB );

  return FLA_SUCCESS;
}

  
